package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayWorkOrderInfoBo;
import com.ruoyi.pay.domain.vo.PayWorkOrderInfoVo;
import com.ruoyi.pay.domain.PayWorkOrderInfo;
import com.ruoyi.pay.mapper.PayWorkOrderInfoMapper;
import com.ruoyi.pay.service.IPayWorkOrderInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 工单信息Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayWorkOrderInfoServiceImpl implements IPayWorkOrderInfoService {

    private final PayWorkOrderInfoMapper baseMapper;

    /**
     * 查询工单信息
     */
    @Override
    public PayWorkOrderInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询工单信息列表
     */
    @Override
    public TableDataInfo<PayWorkOrderInfoVo> queryPageList(PayWorkOrderInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayWorkOrderInfo> lqw = buildQueryWrapper(bo);
        Page<PayWorkOrderInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询工单信息列表
     */
    @Override
    public List<PayWorkOrderInfoVo> queryList(PayWorkOrderInfoBo bo) {
        LambdaQueryWrapper<PayWorkOrderInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayWorkOrderInfo> buildQueryWrapper(PayWorkOrderInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayWorkOrderInfo> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayWorkOrderInfo::getTenantId, bo.getTenantId());
        lqw.eq(bo.getProductId() != null, PayWorkOrderInfo::getProductId, bo.getProductId());
        lqw.eq(bo.getDeptId() != null, PayWorkOrderInfo::getDeptId, bo.getDeptId());
        lqw.eq(bo.getNumbers() != null, PayWorkOrderInfo::getNumbers, bo.getNumbers());
        lqw.eq(bo.getPrice() != null, PayWorkOrderInfo::getPrice, bo.getPrice());
        lqw.eq(StringUtils.isNotBlank(bo.getBookPerson()), PayWorkOrderInfo::getBookPerson, bo.getBookPerson());
        lqw.eq(StringUtils.isNotBlank(bo.getQualityPerson()), PayWorkOrderInfo::getQualityPerson, bo.getQualityPerson());
        lqw.eq(bo.getTotalAmount() != null, PayWorkOrderInfo::getTotalAmount, bo.getTotalAmount());
        lqw.eq(bo.getCompleteTime() != null, PayWorkOrderInfo::getCompleteTime, bo.getCompleteTime());
        lqw.eq(StringUtils.isNotBlank(bo.getState()), PayWorkOrderInfo::getState, bo.getState());
        lqw.eq(bo.getBaohuoHours() != null, PayWorkOrderInfo::getBaohuoHours, bo.getBaohuoHours());
        lqw.eq(bo.getDeleted() != null, PayWorkOrderInfo::getDeleted, bo.getDeleted());
        return lqw;
    }

    /**
     * 新增工单信息
     */
    @Override
    public Boolean insertByBo(PayWorkOrderInfoBo bo) {
        PayWorkOrderInfo add = BeanUtil.toBean(bo, PayWorkOrderInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改工单信息
     */
    @Override
    public Boolean updateByBo(PayWorkOrderInfoBo bo) {
        PayWorkOrderInfo update = BeanUtil.toBean(bo, PayWorkOrderInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayWorkOrderInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除工单信息
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
